'From Squeak3.6beta of ''4 July 2003'' [latest update: #5395] on 24 August 2003 at 9:40:48 am'!
"Change Set:		Chronology-b-Tests-SqueakAndSmalltalk80Compatibility
Date:			24 August 2003
Author:			Brent Pinkney

This change set tests the existing 3.6 Date,Time,TimeStamp,Week, and Month classes"!

TestCase subclass: #ClassTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology-Tests'!

!ClassTestCase commentStamp: 'brp 7/26/2003 16:57' prior: 0!
This class is intended for unit tests of individual classes and their metaclasses.

It provides methods to determine the coverage of the unit tests.

Subclasses are expected to re-implement #classesToBeTested and #selectorsToBeIgnored.

They should also implement to confirm that all methods have been tested.

#testCoverage

	super testCoverage.

!

ClassTestCase subclass: #DateTest
	instanceVariableNames: 'date '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology-Tests'!

!DateTest commentStamp: 'brp 7/26/2003 16:58' prior: 0!
This is the unit test for the class Date. !

ClassTestCase subclass: #MonthTest
	instanceVariableNames: 'month '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology-Tests'!

!MonthTest commentStamp: 'brp 7/26/2003 22:44' prior: 0!
This is the unit test for the class Month.
!

ClassTestCase subclass: #TimeStampTest
	instanceVariableNames: 'timestamp '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology-Tests'!

!TimeStampTest commentStamp: 'brp 7/26/2003 22:44' prior: 0!
This is the unit test for the class TimeStamp.!

ClassTestCase subclass: #TimeTest
	instanceVariableNames: 'time '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology-Tests'!

!TimeTest commentStamp: 'brp 7/26/2003 22:44' prior: 0!
This is the unit test for the class Time.
!

ClassTestCase subclass: #WeekTest
	instanceVariableNames: 'week '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology-Tests'!

!ClassTestCase methodsFor: 'Tests' stamp: 'brp 7/26/2003 16:36'!
testCoverage

	| untested | 
	untested := self selectorsNotTested.
	self assert: untested isEmpty 
		description: untested size asString, ' selectors are not covered'.! !

!ClassTestCase methodsFor: 'Private' stamp: 'brp 8/6/2003 19:24'!
resumeFromDeprecatedMethods: autoResume
	"If true, make the default action for all Deprecation warnings to resume"

	| da |
	autoResume
		ifTrue: [Deprecation compiledMethodAt: #defaultAction ifAbsent: 
					[ Deprecation 
						addSelector: #defaultAction 
						withMethod: (Notification >> #defaultAction) ] ]
		ifFalse: [da _ Deprecation compiledMethodAt: #defaultAction ifAbsent: [].
				da == (Notification >> #defaultAction) 
					ifTrue: [ Deprecation removeSelectorSimply: #defaultAction] ]
				


! !

!ClassTestCase methodsFor: 'Running' stamp: 'brp 8/6/2003 19:25'!
setUp

	self resumeFromDeprecatedMethods: true.! !

!ClassTestCase methodsFor: 'Running' stamp: 'brp 8/6/2003 19:26'!
tearDown

	self resumeFromDeprecatedMethods: false.! !

!ClassTestCase methodsFor: 'Coverage' stamp: 'brp 7/27/2003 12:39'!
classToBeTested
	
	self subclassResponsibility! !

!ClassTestCase methodsFor: 'Coverage' stamp: 'brp 7/26/2003 16:35'!
selectorsNotTested

	^ self selectorsToBeTested difference: self selectorsTested.
! !

!ClassTestCase methodsFor: 'Coverage' stamp: 'brp 7/26/2003 17:36'!
selectorsTested
	| literals |
	literals _ Set new.
	self class
		selectorsAndMethodsDo: [ :s :m | (s beginsWith: 'test')
			ifTrue: [ literals addAll: (m literals select: [ :l | l isSymbol and: [l first isLowercase]]) ] ].
	^ literals! !

!ClassTestCase methodsFor: 'Coverage' stamp: 'brp 7/26/2003 17:22'!
selectorsToBeIgnored
	^ #(#DoIt #DoItIn:)! !

!ClassTestCase methodsFor: 'Coverage' stamp: 'brp 7/27/2003 12:40'!
selectorsToBeTested

	^ ( { self classToBeTested. self classToBeTested class } gather: [:c | c selectors]) 
			difference: self selectorsToBeIgnored! !


!ClassTestCase class methodsFor: 'Testing' stamp: 'brp 7/27/2003 12:53'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self sunitName = #ClassTestCase
			! !


!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:04'!
testAccessing

	self	
		assert: date day = 153;
		assert: date julianDayNumber = 2441836;
		assert: date leap = 0;
		assert: date monthIndex = 6;
		assert: date monthName = #June;
		assert: date weekday = #Saturday;
		assert: date weekdayIndex = 6;
		assert: date year = 1973.
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:10'!
testArithmetic
	| d |
	d := date addDays: 32.		"4 July 1973"

	self 
		assert: d year = 1973;
		assert: d monthIndex = 7;
		assert: d dayOfMonth = 4.
	self 
		assert: (d subtractDate: date) = 32;
		assert: (date subtractDate: d) = -32.
	self	 
		assert: (d subtractDays: 32) = date.
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:54'!
testComparing
	| d1 d2 d3 |
	d1 := self dateClass newDay: 2 month: #June year: 1973.
	d2 := self dateClass newDay: 97 year: 2003. 		"7 April 2003"
	d3 := self dateClass newDay: 250 year: 1865. 		"7 September 1865"

	self
		assert: date = d1;
		assert: date = date copy;
		assert: date hash = d1 hash.
	self 
		assert: date < d2;
		deny: date < d3.
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:15'!
testConverting

	self 
		assert: date asDate = date;
		assert: '2 June 1973' asDate = date;
		assert: date asSeconds = 2285280000.

	date dayMonthYearDo: [ :d :m :y | self assert: d = 2; assert: m = 6; assert: y = 1973 ].! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:29'!
testFromDays
	| epoch d0 d1 d2 |
	epoch := self dateClass newDay: 1 year: 1901.
	d0 := self dateClass fromDays: 0. 			"1 January 1901"
	self assert: d0 = epoch.

	d1 := self dateClass fromDays:  26450. 	"2 June 1973"
	self assert: d1 = date.

	d2 := self dateClass fromDays: -100000.	"18 March 1627"
	self assert: d2 julianDayNumber = 2315386.
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:17'!
testFromSeconds
	| d |
	d := self dateClass fromSeconds: 2285280000. 
	self
		assert: d = date.
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:30'!
testGeneralInquiries

	| shuffled indices names now | 

	shuffled := #(#January #February #March #April #May #June #July 
					#August #September #October #November #December) shuffled.
	indices := shuffled collect: [ :m | self dateClass indexOfMonth: m ].
	names := indices collect: [ :i | self dateClass nameOfMonth: i ].
	self assert: names = shuffled.

	shuffled := #(#Monday #Tuesday #Wednesday #Thursday #Friday #Saturday #Sunday) shuffled.
	indices := shuffled collect: [ :m | self dateClass dayOfWeek: m ].
	names := indices collect: [ :i | self dateClass nameOfDay: i ].
	self assert: names = shuffled.
	
	now  := self dateClass dateAndTimeNow.
	self 
		assert: now size = 2;
		assert: now first = self dateClass today.

	self assert: (self dateClass firstWeekdayOfMonth: #June year: 1973) = 6.

	self
		assert: (self dateClass leapYear: 1973) = 0;
		assert: (self dateClass leapYear: 1972) = 1;
		assert: (self dateClass daysInYear: 1973) = 365;
		assert: (self dateClass daysInYear: 1972) = 366;
		assert: (self dateClass daysInMonth: #February forYear: 1973) = 28;
		assert: (self dateClass daysInMonth: #February forYear: 1972) = 29.
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:17'!
testInitialization

	self should: [ self dateClass initialize. true ].
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:18'!
testInquiries

	self	
		assert: date dayOfMonth = 2;
		assert: date dayOfYear = 153;
		assert: date daysInMonth = 30;
		assert: date daysInYear = 365;
		assert: date daysLeftInYear = (365 - 153);
		assert: date firstDayOfMonth = 152.
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:05'!
testNew
	| epoch |
	epoch := self dateClass newDay: 1 year: 1901.
	self assert: (self dateClass new = epoch).! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:20'!
testPreviousNext
	| n p pt |
	n := date next.
	p := date previous.

	self
		assert: n year = 1973;
		assert: n dayOfYear = 154;
		assert: p year = 1973;
		assert: p dayOfYear = 152.

	pt := date previous: #Thursday.		"31 May 1973"
	self	
		assert: pt year = 1973;
		assert: pt dayOfYear = 151.
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:21'!
testPrinting

	self	
		assert: date mmddyyyy = '6/2/1973';
		assert: date yyyymmdd = '1973-06-02';
		assert: (date printFormat: #(3 1 2 $!! 2 1 1)) = '1973!!2!!Jun'.
! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:23'!
testReadFrom
	| s1 s2 s3 s4 s5 | 
	s1 := '2 June 1973'.
	s2 := '2-JUN-73'.
	s3 := 'June 2, 1973'.
	s4 := '6/2/73'.
	s5 := '2JUN73'.

	self	
		assert: date = (self dateClass readFrom: s1 readStream);
		assert: date = (self dateClass readFrom: s2 readStream);
		assert: date = (self dateClass readFrom: s3 readStream);
		assert: date = (self dateClass readFrom: s4 readStream);
		assert: date = (self dateClass readFrom: s5 readStream).! !

!DateTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:05'!
testStoring

	self	
		assert: date storeString = '''2 June 1973'' asDate';
		assert: date = ('2 June 1973' asDate).
! !

!DateTest methodsFor: 'Private' stamp: 'brp 7/27/2003 13:01'!
dateClass

	^ Date! !

!DateTest methodsFor: 'Coverage' stamp: 'brp 7/27/2003 13:01'!
classToBeTested

	^ self dateClass! !

!DateTest methodsFor: 'Coverage' stamp: 'brp 7/27/2003 14:05'!
selectorsToBeIgnored

	 | deprecated private special |
	deprecated := #(
		#fromJulianDayNumber:
		#uniqueDateStringBetween:and:
		#daylightSavingsInEffectAtStandardHour:
		#daylightSavingsInEffect
		#asGregorian
		#asJulianDayNumber
		#day:year:
		#firstDayOfMonthIndex:
		#mmddyy
		#absoluteDaysToYear:
		#yearAndDaysFromDays:into:
		#week
		#month ).

	private := #( #julianDayNumber: ).

	special := #( #< #= #new #next #previous #printOn: #printOn:format: #storeOn: #fromString: ).

	^ super selectorsToBeIgnored, deprecated, private, special! !

!DateTest methodsFor: 'Running' stamp: 'brp 7/27/2003 13:03'!
setUp

	date := self dateClass newDay: 153 year: 1973.	"2 June 1973"
! !

!DateTest methodsFor: 'Running' stamp: 'brp 7/27/2003 13:03'!
tearDown

	date := nil
! !


!MonthTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 22:52'!
testConverting

	self assert: month asDate = '1 July 1998' asDate! !

!MonthTest methodsFor: 'Tests' stamp: 'brp 8/5/2003 22:43'!
testDeprecated

	self 
		assert: month firstDate = '1 July 1998' asDate;
		assert: month lastDate = '31 July 1998' asDate.! !

!MonthTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 23:38'!
testEnumerating

	| weeks |
	weeks := OrderedCollection new.
	month eachWeekDo: [ :w | weeks add: w firstDate ].

	0 to: 4 do: [ :i | weeks remove: 
		(Week fromDate: ('29 June 1998' asDate addDays: i * 7)) firstDate ].

	self assert: weeks isEmpty
! !

!MonthTest methodsFor: 'Tests' stamp: 'brp 8/6/2003 19:39'!
testInquiries

	self 
		assert: month index = 7;
		assert: month name = #July;
		assert: month duration = 31 description: 'Month duration has changed'
! !

!MonthTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 23:05'!
testInstanceCreation

	| m1 m2 |
	m1 := Month fromDate: '4 July 1998' asDate.
	m2 := Month month: #July year: 1998.
	
	self
		assert: month = m1;
		assert: month = m2.

! !

!MonthTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 23:02'!
testPreviousNext
	| n p |
	n := month next.
	p := month previous.

	self
		assert: n year = 1998;
		assert: n index = 8;
		assert: p year = 1998;
		assert: p index = 6.

! !

!MonthTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 22:50'!
testPrinting

	self 
		assert: month printString = 'July 1998'.
! !

!MonthTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 22:46'!
testReadFrom

	| m |
	m := Month readFrom: 'July 1998' readStream.
	self 
		assert: m = month! !

!MonthTest methodsFor: 'Coverage' stamp: 'brp 7/27/2003 12:42'!
classToBeTested

	^ Month! !

!MonthTest methodsFor: 'Coverage' stamp: 'brp 7/26/2003 23:29'!
selectorsToBeIgnored

	| deprecated private special |
	deprecated := #().
	private := #( #printOn: ).
	special := #( #next ).

	^ super selectorsToBeIgnored, deprecated, private, special.! !

!MonthTest methodsFor: 'Running' stamp: 'brp 8/6/2003 19:37'!
setUp

	super setUp.
	month _ Month month: 7 year: 1998.! !

!MonthTest methodsFor: 'Running' stamp: 'brp 8/6/2003 19:37'!
tearDown

	super tearDown.
	month _ nil.! !


!TimeStampTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 21:56'!
testAccessing

	| d t |
	d := '1-10-2000' asDate.
	t := '11:55:00 am' asTime.

	self
		assert: timestamp date = d;
		assert: timestamp time = t.
! !

!TimeStampTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 22:05'!
testArithmetic

	| ts |
	ts := timestamp minusDays: 123.  	"9 September 1999, 11:55 am"
	ts := ts minusSeconds: 1056.			"9 September 1999, 11:37:24 am"
	ts := ts plusDays: 123.				"10 January 2000, 11:37:24 am"
	ts := ts plusSeconds: 1056.			"10 January 2000, 11:55 am"
	self
		assert: ts  = timestamp.

	! !

!TimeStampTest methodsFor: 'Tests' stamp: 'brp 8/23/2003 17:35'!
testComparing

	| ts1 ts2 ts3 |
	ts1 := self timestampClass date: ('01-10-2000' asDate) time: ('11:55:00 am' asTime).
	ts2 := self timestampClass date: ('07-26-2003' asDate) time: ('22:09:45 am' asTime).
	ts3 := self timestampClass date: ('05-28-1972' asDate) time: ('04:31:14 pm' asTime).

	self
		assert: ts1 = timestamp;
		assert: ts1 hash = timestamp hash;
		assert: timestamp = timestamp copy;
		assert: ts1 < ts2;
		deny: ts1 < ts3.

! !

!TimeStampTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 22:19'!
testConverting

	| d t |
	d := '1-10-2000' asDate.
	t := '11:55:00 am' asTime.

	self
		assert: timestamp asSeconds = (d asSeconds + t asSeconds);
		assert: timestamp asDate = d;
		assert: timestamp asTime = t;
		assert: timestamp asTimeStamp == timestamp;
		assert: timestamp dateAndTime = {d. t}.
! !

!TimeStampTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:55'!
testFromSeconds

	self
		assert: (self timestampClass fromSeconds: 3124958100) = timestamp.! !

!TimeStampTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:56'!
testFromString
	"This should signal an exception in 3.6beta as Time>>fromString: does not exist."

	self should: [ self timestampClass fromString: '1-10-2000 11:55:00 am'. ] 
			raise: MessageNotUnderstood.

! !

!TimeStampTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:58'!
testInstanceCreation

	self should: [ self timestampClass midnight ] 
			raise: MessageNotUnderstood;
		should: [ self timestampClass midnightOn: timestamp date ] 
			raise: MessageNotUnderstood;
		should: [ self timestampClass noon ] 
			raise: MessageNotUnderstood;
		should: [ self timestampClass noonOn: timestamp date ] 
			raise: MessageNotUnderstood.
! !

!TimeStampTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 22:16'!
testPrinting

	self	
		assert: timestamp printString = '10 January 2000, 11:55 am'.
! !

!TimeStampTest methodsFor: 'Tests' stamp: 'brp 8/23/2003 17:47'!
testSorting

	| c1 c2 |
	c1 _ self timestampClass current.
	c2 _ self timestampClass current.

	self
		assert: (self timestampClass current) <= (self timestampClass current);
		assert: (c1 <= c2).


! !

!TimeStampTest methodsFor: 'Coverage' stamp: 'brp 7/27/2003 13:50'!
classToBeTested

	^ self timestampClass! !

!TimeStampTest methodsFor: 'Coverage' stamp: 'brp 7/27/2003 14:04'!
selectorsToBeIgnored

	| deprecated private special |

	deprecated := #( #<= #>= #> ).
	private := #( #date: #time: #printOn: ).
	special := #( #< #= ).

	^ super selectorsToBeIgnored, deprecated, private, special.! !

!TimeStampTest methodsFor: 'Private' stamp: 'brp 7/27/2003 13:50'!
timestampClass

	^ TimeStamp! !

!TimeStampTest methodsFor: 'Running' stamp: 'brp 7/27/2003 14:00'!
setUp

	timestamp := self timestampClass date: ('1-10-2000' asDate) time: ('11:55:00 am' asTime).! !

!TimeStampTest methodsFor: 'Running' stamp: 'brp 7/26/2003 21:53'!
tearDown

	timestamp := nil.! !


!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:33'!
testAccessing

	self
		assert: time hours = 4;
		assert: time minutes = 2;
		assert: time seconds = 47;
		assert: time asSeconds = 14567.
! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:35'!
testArithmetic
	| t1 t2 t3 |
	t1 := time addSeconds: 70.		"4:03:57 am"
	self
		assert: t1 hours = 4;
		assert: t1 minutes = 3;
		assert: t1 seconds = 57.

	t2 := t1 addTime: (self timeClass fromSeconds: (60*60*5)).
	self
		assert: t2 hours = 9;
		assert: t2 minutes = 3;
		assert: t2 seconds = 57.

	t3 := t2 subtractTime: (self timeClass fromSeconds: (60*60*5) + 70).
	self
		assert: t3 = time.
! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:36'!
testComparing
	| t1 t2 t3 |
	t1 := self timeClass fromSeconds: 14567.		"4:02:47 am"
	t2 := self timeClass fromSeconds: 5000.		"1:23:20 am"
	t3 := self timeClass fromSeconds: 80000.		"10:13:20 pm"

	self
		assert: time = t1;
		assert: time hash = t1 hash;
		assert: time = time copy.
	self
		deny: t1 < t2;
		assert: t1 < t3.! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:37'!
testConverting

	self
		assert: time asSeconds = 14567.! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:38'!
testFromSeconds
	| t |
	t := self timeClass fromSeconds: 14567.
	self
		assert: t = time
! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:52'!
testGeneralInquiries
	| now d t dt |

	now  := self timeClass dateAndTimeNow.
	self 
		assert: now size = 2;
		assert: now last <= self timeClass now.

	self should: [ self timeClass timeWords ] raise: MessageNotUnderstood.

	d := '2 June 1973' asDate.
	t := '4:02:47 am' asTime.
	dt := self timeClass dateAndTimeFromSeconds: (2285280000 + 14567).
	self
		assert: dt = {d. t.}.
! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:44'!
testNew
	
	self assert: self timeClass new asSeconds = 0! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:45'!
testPrinting

	self	
		assert: time printString = '4:02:47 am';
		assert: time intervalString = ' 4 hours 2 minutes';
		assert: time print24 = '04:02:47';
		assert: time printMinutes = '4:02 am';
		assert: time hhmm24 = '0402'.
! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:46'!
testReadFrom

	| string t |
	string := '4:02:47 am'.
	t := self timeClass readFrom: string readStream.

	self
		assert: time = t.
! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:49'!
testSqueakInquiries
	| timewords totalseconds condensed corrected |
	self assert: 
		(self timeClass namesForTimes: #(2 10000023 10000026))
			= #('January, 1901' 'April, 1901, 4/26/1901, 5:47 pm' 'April, 1901, 4/26/1901, 5:47 pm').

	timewords := #(0.5 30 62 130 4000 10000 60000 90000) 
		collect: [ :ss | self timeClass humanWordsForSecondsAgo: ss ].
	self assert: 
		timewords = #('a second ago' '30 seconds ago' 'a minute ago' '2 minutes ago' 
			'an hour ago' '2 hours ago' '16 hours ago' 'yesterday').

	totalseconds :=  self timeClass totalSeconds.
	condensed := self timeClass condenseBunches: 
		(#(20 400 401  20000 20200 20300 40000 45000  200000 201000 202000) 
			collect: [:tt | totalseconds - tt]).
	corrected := condensed collect: [ :e | totalseconds - e ].
	self
		assert: (corrected includesAllOf: #(20 400 401 20000 40000 45000 200000)).
! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:47'!
testStoring

	self	
		assert: time storeString = '''4:02:47 am'' asTime';
		assert: time = ('4:02:47 am' asTime).
! !

!TimeTest methodsFor: 'Tests' stamp: 'brp 7/27/2003 13:47'!
testTiming

	self assert: (
		(self timeClass millisecondsToRun: [ (Delay forMilliseconds: 50) wait ]) 
			between: 50 and: 55).! !

!TimeTest methodsFor: 'Coverage' stamp: 'brp 7/27/2003 13:31'!
classToBeTested

	^ self timeClass! !

!TimeTest methodsFor: 'Coverage' stamp: 'brp 7/27/2003 14:04'!
selectorsToBeIgnored

	 | deprecated private special primitives timing benchmarks |

	deprecated := #().
	private := #( #hours: #hours:minutes:seconds: #setSeconds: #print24:on: #print24:showSeconds:on: ).
	special := #( #< #= #new #printOn: #storeOn: ).
	primitives := #( #primMillisecondClock #primSecondsClock ).
	timing := #( #millisecondClockValue #milliseconds:since: #millisecondsSince: ).
	benchmarks := #( #benchmarkMillisecondClock #benchmarkPrimitiveResponseDelay ). 

	^ super selectorsToBeIgnored, deprecated, private, special, primitives, timing, benchmarks.! !

!TimeTest methodsFor: 'Running' stamp: 'brp 7/27/2003 13:33'!
setUp

	time := self timeClass fromSeconds: 14567.		"4:02:47 am"! !

!TimeTest methodsFor: 'Running' stamp: 'brp 7/27/2003 13:33'!
tearDown

	time := nil! !

!TimeTest methodsFor: 'Private' stamp: 'brp 7/27/2003 13:32'!
timeClass

	^ Time! !


!WeekTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 23:28'!
testEnumerating

	| days |
	days := OrderedCollection new.
	0 to: 6 do: [ :i | days add: ('29 June 1998' asDate addDays: i) ].

	week do: [ :d | days remove: d ].
	
	self assert: days isEmpty.
! !

!WeekTest methodsFor: 'Tests' stamp: 'brp 8/6/2003 19:34'!
testInquiries

	self
		assert: week firstDate = '29 June 1998' asDate;
		assert: week lastDate = '5 July 1998' asDate;
		assert: week index = 5;
		assert: week duration = 7 description: 'Week>>#duration has changed'.
! !

!WeekTest methodsFor: 'Tests' stamp: 'brp 7/26/2003 23:19'!
testPreviousNext

	self
		assert: week next = (Week fromDate: '6 July 1998' asDate);
		assert: week previous = (Week fromDate: '22 June 1998' asDate).

! !

!WeekTest methodsFor: 'Coverage' stamp: 'brp 7/27/2003 12:42'!
classToBeTested

	^ Week! !

!WeekTest methodsFor: 'Coverage' stamp: 'brp 7/26/2003 23:43'!
selectorsToBeIgnored

	| deprecated private special |

	deprecated := #( #startMonday #toggleStartMonday).
	private := #( #indexInMonth: #printOn: ).
	special := #( #next #do: ).

	^ super selectorsToBeIgnored, deprecated, private, special.! !

!WeekTest methodsFor: 'Running' stamp: 'brp 8/6/2003 19:25'!
setUp
	"June 1998, 5th week"

	super setUp.

	Week startMonday ifFalse: [ Week toggleStartMonday ].
	week _ Week fromDate: '4 July 1998' asDate.
! !

!WeekTest methodsFor: 'Running' stamp: 'brp 8/6/2003 19:26'!
tearDown

	super tearDown.
	week _ nil.

! !


!TimeTest reorganize!
('Tests' testAccessing testArithmetic testComparing testConverting testFromSeconds testGeneralInquiries testNew testPrinting testReadFrom testSqueakInquiries testStoring testTiming)
('Coverage' classToBeTested selectorsToBeIgnored)
('Running' setUp tearDown)
('Private' timeClass)
!


!DateTest reorganize!
('Tests' testAccessing testArithmetic testComparing testConverting testFromDays testFromSeconds testGeneralInquiries testInitialization testInquiries testNew testPreviousNext testPrinting testReadFrom testStoring)
('Private' dateClass)
('Coverage' classToBeTested selectorsToBeIgnored)
('Running' setUp tearDown)
!


!ClassTestCase reorganize!
('Tests' testCoverage)
('Private' resumeFromDeprecatedMethods:)
('Running' setUp tearDown)
('Coverage' classToBeTested selectorsNotTested selectorsTested selectorsToBeIgnored selectorsToBeTested)
!

